## xtl 0.6.9

=== CMakeLists.txt ===
############################################################################
# Copyright (c) Johan Mabille, Sylvain Corlay and Wolf Vollprecht          #
# Copyright (c) QuantStack                                                 #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.1)
project(xtl)

enable_testing()

set(XTL_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

# Versioning
# ===========

file(STRINGS "${XTL_INCLUDE_DIR}/xtl/xtl_config.hpp" xtl_version_defines
     REGEX "#define XTL_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${xtl_version_defines})
    if(ver MATCHES "#define XTL_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XTL_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(${PROJECT_NAME}_VERSION
    ${XTL_VERSION_MAJOR}.${XTL_VERSION_MINOR}.${XTL_VERSION_PATCH})
message(STATUS "xtl v${${PROJECT_NAME}_VERSION}")

# Dependencies
# ============

find_package(nlohmann_json QUIET)

# Build
# =====

set(XTL_HEADERS
    ${XTL_INCLUDE_DIR}/xtl/xany.hpp
    ${XTL_INCLUDE_DIR}/xtl/xbasic_fixed_string.hpp
    ${XTL_INCLUDE_DIR}/xtl/xbase64.hpp
    ${XTL_INCLUDE_DIR}/xtl/xclosure.hpp
    ${XTL_INCLUDE_DIR}/xtl/xcomplex.hpp
    ${XTL_INCLUDE_DIR}/xtl/xcomplex_sequence.hpp
    ${XTL_INCLUDE_DIR}/xtl/xspan.hpp
    ${XTL_INCLUDE_DIR}/xtl/xspan_impl.hpp
    ${XTL_INCLUDE_DIR}/xtl/xdynamic_bitset.hpp
    ${XTL_INCLUDE_DIR}/xtl/xfunctional.hpp
    ${XTL_INCLUDE_DIR}/xtl/xhash.hpp
    ${XTL_INCLUDE_DIR}/xtl/xhierarchy_generator.hpp
    ${XTL_INCLUDE_DIR}/xtl/xiterator_base.hpp
    ${XTL_INCLUDE_DIR}/xtl/xjson.hpp
    ${XTL_INCLUDE_DIR}/xtl/xmasked_value_meta.hpp
    ${XTL_INCLUDE_DIR}/xtl/xmasked_value.hpp
    ${XTL_INCLUDE_DIR}/xtl/xmeta_utils.hpp
    ${XTL_INCLUDE_DIR}/xtl/xoptional_meta.hpp
    ${XTL_INCLUDE_DIR}/xtl/xoptional.hpp
    ${XTL_INCLUDE_DIR}/xtl/xoptional_sequence.hpp
    ${XTL_INCLUDE_DIR}/xtl/xproxy_wrapper.hpp
    ${XTL_INCLUDE_DIR}/xtl/xsequence.hpp
    ${XTL_INCLUDE_DIR}/xtl/xtl_config.hpp
    ${XTL_INCLUDE_DIR}/xtl/xtype_traits.hpp
    ${XTL_INCLUDE_DIR}/xtl/xvariant.hpp
    ${XTL_INCLUDE_DIR}/xtl/xvariant_impl.hpp
)

add_library(xtl INTERFACE)
target_include_directories(xtl INTERFACE $<BUILD_INTERFACE:${XTL_INCLUDE_DIR}>
                                         $<INSTALL_INTERFACE:include>)

# xtl requires C++14 support!
target_compile_features(xtl INTERFACE cxx_std_14)


option(BUILD_TESTS "xtl test suite" OFF)
option(DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)
option(XTL_DISABLE_EXCEPTIONS "Disable C++ exceptions" OFF)

if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    set(BUILD_TESTS ON)
endif()

if(BUILD_TESTS)
    add_subdirectory(test)
endif()

# Installation
# ============

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

install(TARGETS xtl
        EXPORT ${PROJECT_NAME}-targets)

# Makes the project importable from the build directory
export(EXPORT ${PROJECT_NAME}-targets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")

install(FILES ${XTL_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xtl)

set(XTL_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE
    STRING "install path for xtlConfig.cmake")

configure_package_config_file(${PROJECT_NAME}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${XTL_CMAKECONFIG_INSTALL_DIR})

# xtl is header-only and does not depend on the architecture.
# Remove CMAKE_SIZEOF_VOID_P from xtlConfigVersion.cmake so that an xtlConfig.cmake
# generated for a 64 bit target can be used for 32 bit targets and vice versa.
set(_XTL_CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
unset(CMAKE_SIZEOF_VOID_P)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                 VERSION ${${PROJECT_NAME}_VERSION}
                                 COMPATIBILITY AnyNewerVersion)
set(CMAKE_SIZEOF_VOID_P ${_XTL_CMAKE_SIZEOF_VOID_P})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${XTL_CMAKECONFIG_INSTALL_DIR})
install(EXPORT ${PROJECT_NAME}-targets
        FILE ${PROJECT_NAME}Targets.cmake
        DESTINATION ${XTL_CMAKECONFIG_INSTALL_DIR})

configure_file(${PROJECT_NAME}.pc.in
               "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
                @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")

=== test/CMakeLists.txt ===
############################################################################
# Copyright (c) Johan Mabille, Sylvain Corlay and Wolf Vollprecht          #
# Copyright (c) QuantStack                                                 #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(xtl-test)

    enable_testing()

    find_package(xtl REQUIRED CONFIG)
    find_package(nlohmann_json QUIET CONFIG)
    set(XTL_INCLUDE_DIR ${xtl_INCLUDE_DIRS})
endif ()

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if(nlohmann_json_FOUND)
  add_definitions(-DHAVE_NLOHMANN_JSON)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)

    CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
    if (HAS_MARCH_NATIVE)
        add_compile_options(-march=native)
    endif()
    if (XTL_DISABLE_EXCEPTIONS)
        add_compile_options(-fno-exceptions)
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES MSVC)
    add_compile_options(/EHsc /MP /bigobj)
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
    if (XTL_DISABLE_EXCEPTIONS)
        add_compile_options(/EHs-c-)
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES Clang)
  if(NOT WIN32)
    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)

    CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
    if (HAS_MARCH_NATIVE)
        add_compile_options(-march=native)
    endif()
    if (XTL_DISABLE_EXCEPTIONS)
        add_compile_options(-fno-exceptions)
    endif()
  else() # we are using clang-cl
    add_compile_options(/EHsc /MP /bigobj -fms-compatibility)
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
    if (XTL_DISABLE_EXCEPTIONS)
        add_compile_options(/EHs-c-)
    endif()
  endif()
endif()

if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    if(DOWNLOAD_GTEST)
        # Download and unpack googletest at configure time
        configure_file(downloadGTest.cmake.in googletest-download/CMakeLists.txt)
    else()
        # Copy local source of googletest at configure time
        configure_file(copyGTest.cmake.in googletest-download/CMakeLists.txt)
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
    if(result)
        message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
    if(result)
        message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()

    # Add googletest directly to our build. This defines
    # the gtest and gtest_main targets.
    add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                     ${CMAKE_CURRENT_BINARY_DIR}/googletest-build EXCLUDE_FROM_ALL)

    set(GTEST_INCLUDE_DIRS "${gtest_SOURCE_DIR}/include")
    set(GTEST_BOTH_LIBRARIES  gtest_main gtest)
else()
    find_package(GTest REQUIRED)
endif()

find_package(Threads)

include(TestBigEndian)
TEST_BIG_ENDIAN(BIG_ENDIAN)
if(BIG_ENDIAN)
    add_definitions(-DSYSTEM_IS_BIG_ENDIAN)
endif(BIG_ENDIAN)

include_directories(${GTEST_INCLUDE_DIRS})

set(XTL_TESTS
    test_xbase64.cpp
    test_xbasic_fixed_string.cpp
    test_xcomplex.cpp
    test_xcomplex_sequence.cpp
    test_xclosure.cpp
    test_xdynamic_bitset.cpp
    test_xfunctional.cpp
    test_xhash.cpp
    test_xhierarchy_generator.cpp
    test_xiterator_base.cpp
    test_xmasked_value.cpp
    test_xmeta_utils.cpp
    test_xoptional.cpp
    test_xsequence.cpp
    test_xtype_traits.cpp
    test_xproxy_wrapper.cpp
    test_xvariant.cpp
)

if(nlohmann_json_FOUND)
    # Version up to 3.1.2 export the target `nlohmann_json`
    if(TARGET nlohmann_json)
      set(nlohmann_json_TARGET nlohmann_json)
    # Newer versions export the namespaced target `nlohmann_json::nlohmann_json`
    elseif(TARGET nlohmann_json::nlohmann_json)
      set(nlohmann_json_TARGET nlohmann_json::nlohmann_json)
    endif()
endif()

foreach(filename IN LISTS XTL_TESTS)
    get_filename_component(targetname ${filename} NAME_WE)

    add_executable(${targetname} ${filename} ${XTL_HEADERS})
    target_include_directories(${targetname} PRIVATE ${XTL_INCLUDE_DIR})
    target_link_libraries(${targetname} xtl ${GTEST_BOTH_LIBRARIES} Threads::Threads ${nlohmann_json_TARGET})

    add_test(NAME ${targetname} COMMAND ${targetname})
endforeach()

add_executable(test_xtl ${XTL_TESTS} ${XTL_HEADERS})
target_include_directories(test_xtl PRIVATE ${XTL_INCLUDE_DIR})
if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    add_dependencies(test_xtl gtest_main)
endif()
target_link_libraries(test_xtl xtl ${GTEST_BOTH_LIBRARIES} Threads::Threads ${nlohmann_json_TARGET})

add_custom_target(xtest COMMAND test_xtl DEPENDS test_xtl)

=== debian/changelog ===
xtl (0.6.9-1) unstable; urgency=medium

  * Initial release (Closes: #939936)

 -- Vincent Bernat <bernat@debian.org>  Sat, 14 Dec 2019 18:27:18 +0100

=== debian/control ===
Source: xtl
Priority: optional
Maintainer: Debian QuantStack Team <team+debian-quantstack-team@tracker.debian.org>
Uploaders: Vincent Bernat <bernat@debian.org>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libgtest-dev (>= 1.8.1)
Standards-Version: 4.4.0
Section: libs
Homepage: https://github.com/QuantStack/xtl
Vcs-Browser: https://github.com/quantstack-debian/xtl
Vcs-Git: https://github.com/quantstack-debian/xtl.git

Package: xtl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: basic tools (containers, algorithms) used for xtensor and xeus
 This package contains additional containers and tools missing from
 STL C++14. This library is header-only.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%xtl-$1.tar.gz%" \
   https://github.com/QuantStack/xtl/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## xtl 0.6.21

=== debian/changelog ===
xtl (0.6.21-1) unstable; urgency=medium

  [ Gordon Ball ]
  * New upstream version: 0.6.21
  * Make xtl-dev arch:all. As this is a header-only library (+cmake and
    pkg-config metadata), installing to arch-dependent tasks and duplicating
    the package can be avoided. This moves the metadata from usr/lib/tuple to
    usr/share.
  * Patch out use of -march=native in tests. This didn't affect the result
    (since there was no compiled object in the package), but generated build
    log scanning errors. (Closes: #961402)
  * Update Standards-Version to 4.5.0
  * Declare Rules-Requires-Root: no
  * Update homepage to github.com/xtensor-stack/xtl

  [ Vincent Bernat ]
  * Prepare for release

 -- Vincent Bernat <bernat@debian.org>  Sun, 22 Nov 2020 16:02:55 +0100

## xtl 0.6.23

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,12 @@
     set(XTL_INCLUDE_DIR ${xtl_INCLUDE_DIRS})
 endif ()
 
-message(STATUS "Forcing tests build type to Release")
-set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
+if(NOT CMAKE_BUILD_TYPE)
+    message(STATUS "Setting tests build type to Release")
+    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
+else()
+    message(STATUS "Tests build type is ${CMAKE_BUILD_TYPE}")
+endif()
 
 include(CheckCXXCompilerFlag)
 
@@ -33,9 +37,11 @@
 if(CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
     add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)
 
-    CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
-    if (HAS_MARCH_NATIVE)
-        add_compile_options(-march=native)
+    if(NOT CMAKE_CXX_FLAGS MATCHES "-march")
+        CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
+        if (HAS_MARCH_NATIVE)
+            add_compile_options(-march=native)
+        endif()
     endif()
     if (XTL_DISABLE_EXCEPTIONS)
         add_compile_options(-fno-exceptions)
@@ -54,15 +60,17 @@
   if(NOT WIN32)
     add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)
 
-    CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
-    if (HAS_MARCH_NATIVE)
-        add_compile_options(-march=native)
+    if(NOT CMAKE_CXX_FLAGS MATCHES "-march")
+        CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
+        if (HAS_MARCH_NATIVE)
+            add_compile_options(-march=native)
+        endif()
     endif()
     if (XTL_DISABLE_EXCEPTIONS)
         add_compile_options(-fno-exceptions)
     endif()
   else() # we are using clang-cl
-    add_compile_options(/EHsc /MP /bigobj -fms-compatibility)
+    add_compile_options(/EHsc /bigobj -fms-compatibility)
     set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
     if (XTL_DISABLE_EXCEPTIONS)
         add_compile_options(/EHs-c-)
@@ -91,24 +99,23 @@
         message(FATAL_ERROR "Build step for googletest failed: ${result}")
     endif()
 
+    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
+
     # Add googletest directly to our build. This defines
     # the gtest and gtest_main targets.
     add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                      ${CMAKE_CURRENT_BINARY_DIR}/googletest-build EXCLUDE_FROM_ALL)
 
     set(GTEST_INCLUDE_DIRS "${gtest_SOURCE_DIR}/include")
-    set(GTEST_BOTH_LIBRARIES  gtest_main gtest)
+    add_library(GTest::GTest INTERFACE IMPORTED)
+    target_link_libraries(GTest::GTest INTERFACE gtest)
+    add_library(GTest::Main INTERFACE IMPORTED)
+    target_link_libraries(GTest::Main INTERFACE gtest_main)
 else()
     find_package(GTest REQUIRED)
 endif()
 
 find_package(Threads)
-
-include(TestBigEndian)
-TEST_BIG_ENDIAN(BIG_ENDIAN)
-if(BIG_ENDIAN)
-    add_definitions(-DSYSTEM_IS_BIG_ENDIAN)
-endif(BIG_ENDIAN)
 
 include_directories(${GTEST_INCLUDE_DIRS})
 
@@ -120,16 +127,21 @@
     test_xclosure.cpp
     test_xdynamic_bitset.cpp
     test_xfunctional.cpp
+    test_xhalf_float.cpp
     test_xhash.cpp
     test_xhierarchy_generator.cpp
     test_xiterator_base.cpp
     test_xmasked_value.cpp
     test_xmeta_utils.cpp
+    test_xmultimethods.cpp
     test_xoptional.cpp
     test_xsequence.cpp
     test_xtype_traits.cpp
+    test_xplatform.cpp
     test_xproxy_wrapper.cpp
+    test_xsystem.cpp
     test_xvariant.cpp
+    test_xvisitor.cpp
 )
 
 if(nlohmann_json_FOUND)
@@ -147,7 +159,7 @@
 
     add_executable(${targetname} ${filename} ${XTL_HEADERS})
     target_include_directories(${targetname} PRIVATE ${XTL_INCLUDE_DIR})
-    target_link_libraries(${targetname} xtl ${GTEST_BOTH_LIBRARIES} Threads::Threads ${nlohmann_json_TARGET})
+    target_link_libraries(${targetname} xtl GTest::GTest GTest::Main Threads::Threads ${nlohmann_json_TARGET})
 
     add_test(NAME ${targetname} COMMAND ${targetname})
 endforeach()
@@ -157,6 +169,7 @@
 if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
     add_dependencies(test_xtl gtest_main)
 endif()
-target_link_libraries(test_xtl xtl ${GTEST_BOTH_LIBRARIES} Threads::Threads ${nlohmann_json_TARGET})
+target_link_libraries(test_xtl xtl GTest::GTest GTest::Main Threads::Threads ${nlohmann_json_TARGET})
 
 add_custom_target(xtest COMMAND test_xtl DEPENDS test_xtl)
+add_test(NAME xtest COMMAND test_xtl)

=== debian/changelog ===
xtl (0.6.23-1) unstable; urgency=medium

  * New upstream version 0.6.23
  * Update patches
    - Drop 0001-Install-cmake-pkgconfig-in-usr-share.patch, upstreamed
    - Patch a failing test in test_xsystem due to assumptions about the
      build directory naming
  * Run the test suite as an autopkgtest

 -- Gordon Ball <gordon@chronitis.net>  Tue, 12 Jan 2021 12:35:53 +0000

=== debian/tests/control ===
Test-Command: cd test && cmake -DGTEST_SRC_DIR=/usr/src/gtest . && make && make test
Depends: xtl-dev, cmake, libgtest-dev, g++
Restrictions: allow-stderr

## xtl 0.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,8 +9,6 @@
 
 cmake_minimum_required(VERSION 3.1)
 project(xtl)
-
-enable_testing()
 
 set(XTL_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
 
@@ -31,7 +29,9 @@
 # Dependencies
 # ============
 
-find_package(nlohmann_json QUIET)
+if(NOT TARGET nlohmann_json)
+    find_package(nlohmann_json QUIET)
+endif()
 
 # Build
 # =====
@@ -47,6 +47,8 @@
     ${XTL_INCLUDE_DIR}/xtl/xspan_impl.hpp
     ${XTL_INCLUDE_DIR}/xtl/xdynamic_bitset.hpp
     ${XTL_INCLUDE_DIR}/xtl/xfunctional.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xhalf_float.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xhalf_float_impl.hpp
     ${XTL_INCLUDE_DIR}/xtl/xhash.hpp
     ${XTL_INCLUDE_DIR}/xtl/xhierarchy_generator.hpp
     ${XTL_INCLUDE_DIR}/xtl/xiterator_base.hpp
@@ -54,24 +56,34 @@
     ${XTL_INCLUDE_DIR}/xtl/xmasked_value_meta.hpp
     ${XTL_INCLUDE_DIR}/xtl/xmasked_value.hpp
     ${XTL_INCLUDE_DIR}/xtl/xmeta_utils.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xmultimethods.hpp
     ${XTL_INCLUDE_DIR}/xtl/xoptional_meta.hpp
     ${XTL_INCLUDE_DIR}/xtl/xoptional.hpp
     ${XTL_INCLUDE_DIR}/xtl/xoptional_sequence.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xplatform.hpp
     ${XTL_INCLUDE_DIR}/xtl/xproxy_wrapper.hpp
     ${XTL_INCLUDE_DIR}/xtl/xsequence.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xsystem.hpp
     ${XTL_INCLUDE_DIR}/xtl/xtl_config.hpp
     ${XTL_INCLUDE_DIR}/xtl/xtype_traits.hpp
     ${XTL_INCLUDE_DIR}/xtl/xvariant.hpp
     ${XTL_INCLUDE_DIR}/xtl/xvariant_impl.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xvisitor.hpp
 )
 
 add_library(xtl INTERFACE)
-target_include_directories(xtl INTERFACE $<BUILD_INTERFACE:${XTL_INCLUDE_DIR}>
-                                         $<INSTALL_INTERFACE:include>)
 
-# xtl requires C++14 support!
+target_include_directories(xtl INTERFACE
+    $<BUILD_INTERFACE:${XTL_INCLUDE_DIR}>
+    $<INSTALL_INTERFACE:include>)
+
+if(NOT (CMAKE_VERSION VERSION_LESS 3.15))  # CMake >= 3.15
+set_target_properties(xtl
+    PROPERTIES
+    PUBLIC_HEADER "${XTL_HEADERS}")
+endif()
+
 target_compile_features(xtl INTERFACE cxx_std_14)
-
 
 option(BUILD_TESTS "xtl test suite" OFF)
 option(DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)
@@ -82,6 +94,7 @@
 endif()
 
 if(BUILD_TESTS)
+    enable_testing()
     add_subdirectory(test)
 endif()
 
@@ -91,17 +104,25 @@
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
 
+if(CMAKE_VERSION VERSION_LESS 3.15)  # CMake < 3.15
 install(TARGETS xtl
         EXPORT ${PROJECT_NAME}-targets)
+else()
+install(TARGETS xtl
+        EXPORT ${PROJECT_NAME}-targets
+        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
+endif()
 
 # Makes the project importable from the build directory
 export(EXPORT ${PROJECT_NAME}-targets
        FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
 
+if(CMAKE_VERSION VERSION_LESS 3.15)  # CMake < 3.15
 install(FILES ${XTL_HEADERS}
         DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xtl)
+endif()
 
-set(XTL_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE
+set(XTL_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME}" CACHE
     STRING "install path for xtlConfig.cmake")
 
 configure_package_config_file(${PROJECT_NAME}Config.cmake.in
@@ -113,9 +134,17 @@
 # generated for a 64 bit target can be used for 32 bit targets and vice versa.
 set(_XTL_CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
 unset(CMAKE_SIZEOF_VOID_P)
-write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
-                                 VERSION ${${PROJECT_NAME}_VERSION}
-                                 COMPATIBILITY AnyNewerVersion)
+# ARCH_INDEPENDENT feature was introduced in cmake 3.14
+if (${CMAKE_VERSION} VERSION_LESS "3.14.0")
+    write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
+                                     VERSION ${${PROJECT_NAME}_VERSION}
+                                     COMPATIBILITY AnyNewerVersion)
+else ()
+    write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
+                                     VERSION ${${PROJECT_NAME}_VERSION}
+                                     COMPATIBILITY AnyNewerVersion
+                                     ARCH_INDEPENDENT)
+endif ()
 set(CMAKE_SIZEOF_VOID_P ${_XTL_CMAKE_SIZEOF_VOID_P})
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
@@ -128,4 +157,4 @@
                "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
                 @ONLY)
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
-        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")
+        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig/")

=== debian/changelog ===
xtl (0.7.2-2~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 13 Sep 2022 16:55:07 -0700

xtl (0.7.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Vincent Bernat <bernat@debian.org>  Sat, 09 Oct 2021 17:26:03 +0200

xtl (0.7.2-1) experimental; urgency=medium

  * New upstream version. Closes: #984872.
  * d/patches: drop -march=native patch
  * d/patches: remove patch for broken test, fixed upstream

 -- Vincent Bernat <bernat@debian.org>  Tue, 09 Mar 2021 21:25:23 +0100

=== debian/control ===
Source: xtl
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian QuantStack Team <team+debian-quantstack-team@tracker.debian.org>
Uploaders: Vincent Bernat <bernat@debian.org>
Build-Depends: cmake, debhelper-compat (= 12), libgtest-dev (>= 1.8.1)
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/xtensor-stack/xtl
Vcs-Browser: https://github.com/quantstack-debian/xtl
Vcs-Git: https://github.com/quantstack-debian/xtl.git
Rules-Requires-Root: no

Package: xtl-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}
Description: basic tools (containers, algorithms) used for xtensor and xeus
 This package contains additional containers and tools missing from
 STL C++14. This library is header-only.

=== debian/tests/control ===
Test-Command: cd test && cmake -DGTEST_SRC_DIR=/usr/src/gtest . && make && make test
Depends: cmake, g++, libgtest-dev, xtl-dev
Restrictions: allow-stderr

## xtl 0.7.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,7 @@
     ${XTL_INCLUDE_DIR}/xtl/xbasic_fixed_string.hpp
     ${XTL_INCLUDE_DIR}/xtl/xbase64.hpp
     ${XTL_INCLUDE_DIR}/xtl/xclosure.hpp
+    ${XTL_INCLUDE_DIR}/xtl/xcompare.hpp
     ${XTL_INCLUDE_DIR}/xtl/xcomplex.hpp
     ${XTL_INCLUDE_DIR}/xtl/xcomplex_sequence.hpp
     ${XTL_INCLUDE_DIR}/xtl/xspan.hpp
@@ -88,10 +89,6 @@
 option(BUILD_TESTS "xtl test suite" OFF)
 option(DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)
 option(XTL_DISABLE_EXCEPTIONS "Disable C++ exceptions" OFF)
-
-if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
-    set(BUILD_TESTS ON)
-endif()
 
 if(BUILD_TESTS)
     enable_testing()

=== docs/Makefile ===
# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
INKSCAPE      = inkscape
SED           = sed
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest coverage gettext api

default: html

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*
	rm -rf xml

html:
	doxygen
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	doxygen
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	doxygen
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	doxygen
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	doxygen
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	doxygen
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

epub:
	doxygen
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

tex-generation:
	doxygen
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	${SED} -i.old -e 's/{\([^}]*\)}.svg/\1-svg.pdf/' $(BUILDDIR)/latex/xtl.tex
	(cd $(BUILDDIR)/latex/;\
	for i in *.svg; do\
		name=`basename $$i .svg`;\
		${INKSCAPE} -D -z --file=$$i --export-pdf=$$name-svg.pdf --export-latex; \
	done)

latex: tex-generation
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: tex-generation
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja: tex-generation
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	doxygen
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	doxygen
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	doxygen
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	doxygen
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	doxygen
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	doxygen
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	doxygen
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	doxygen
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

coverage:
	doxygen
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

xml:
	doxygen
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	doxygen
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,9 @@
 ############################################################################
 
 cmake_minimum_required(VERSION 3.1)
+
+find_package(doctest            REQUIRED)
+find_package(Threads)
 
 if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
     project(xtl-test)
@@ -78,51 +81,13 @@
   endif()
 endif()
 
-if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
-    if(DOWNLOAD_GTEST)
-        # Download and unpack googletest at configure time
-        configure_file(downloadGTest.cmake.in googletest-download/CMakeLists.txt)
-    else()
-        # Copy local source of googletest at configure time
-        configure_file(copyGTest.cmake.in googletest-download/CMakeLists.txt)
-    endif()
-    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
-                    RESULT_VARIABLE result
-                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
-    if(result)
-        message(FATAL_ERROR "CMake step for googletest failed: ${result}")
-    endif()
-    execute_process(COMMAND ${CMAKE_COMMAND} --build .
-                    RESULT_VARIABLE result
-                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
-    if(result)
-        message(FATAL_ERROR "Build step for googletest failed: ${result}")
-    endif()
-
-    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
-
-    # Add googletest directly to our build. This defines
-    # the gtest and gtest_main targets.
-    add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
-                     ${CMAKE_CURRENT_BINARY_DIR}/googletest-build EXCLUDE_FROM_ALL)
-
-    set(GTEST_INCLUDE_DIRS "${gtest_SOURCE_DIR}/include")
-    add_library(GTest::GTest INTERFACE IMPORTED)
-    target_link_libraries(GTest::GTest INTERFACE gtest)
-    add_library(GTest::Main INTERFACE IMPORTED)
-    target_link_libraries(GTest::Main INTERFACE gtest_main)
-else()
-    find_package(GTest REQUIRED)
-endif()
-
 find_package(Threads)
-
-include_directories(${GTEST_INCLUDE_DIRS})
 
 set(XTL_TESTS
     test_xbase64.cpp
     test_xbasic_fixed_string.cpp
     test_xcomplex.cpp
+    test_xcompare.cpp
     test_xcomplex_sequence.cpp
     test_xclosure.cpp
     test_xdynamic_bitset.cpp
@@ -157,19 +122,16 @@
 foreach(filename IN LISTS XTL_TESTS)
     get_filename_component(targetname ${filename} NAME_WE)
 
-    add_executable(${targetname} ${filename} ${XTL_HEADERS})
+    add_executable(${targetname} main.cpp  ${filename} ${XTL_HEADERS})
     target_include_directories(${targetname} PRIVATE ${XTL_INCLUDE_DIR})
-    target_link_libraries(${targetname} xtl GTest::GTest GTest::Main Threads::Threads ${nlohmann_json_TARGET})
+    target_link_libraries(${targetname} xtl doctest::doctest Threads::Threads ${nlohmann_json_TARGET})
 
     add_test(NAME ${targetname} COMMAND ${targetname})
 endforeach()
 
-add_executable(test_xtl ${XTL_TESTS} ${XTL_HEADERS})
+add_executable(test_xtl main.cpp ${XTL_TESTS} ${XTL_HEADERS})
 target_include_directories(test_xtl PRIVATE ${XTL_INCLUDE_DIR})
-if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
-    add_dependencies(test_xtl gtest_main)
-endif()
-target_link_libraries(test_xtl xtl GTest::GTest GTest::Main Threads::Threads ${nlohmann_json_TARGET})
+target_link_libraries(test_xtl xtl doctest::doctest Threads::Threads ${nlohmann_json_TARGET})
 
 add_custom_target(xtest COMMAND test_xtl DEPENDS test_xtl)
 add_test(NAME xtest COMMAND test_xtl)

=== debian/changelog ===
xtl (0.7.5-3) unstable; urgency=medium

  * d/test: add missing xtl-dev dependency. Closes: #1052544.
  * d/patches: add patch to fix test/CMakeLists.txt.

 -- Vincent Bernat <bernat@debian.org>  Wed, 04 Oct 2023 10:53:52 +0200

xtl (0.7.5-2) unstable; urgency=medium

  * Upload to unstable.

 -- Vincent Bernat <bernat@debian.org>  Sat, 23 Sep 2023 16:30:07 +0200

xtl (0.7.5-1) experimental; urgency=medium

  * New upstream version. Closes: #1029992.

 -- Vincent Bernat <bernat@debian.org>  Thu, 02 Feb 2023 20:37:04 +0100

=== debian/tests/control ===
Test-Command: cd test && cmake -DGTEST_SRC_DIR=/usr/src/gtest . && make && make test
Depends: xtl-dev, cmake, libgtest-dev, doctest-dev, g++
Restrictions: allow-stderr

## xtl 0.7.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # The full license is in the file LICENSE, distributed with this software. #
 ############################################################################
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.5)
 project(xtl)
 
 set(XTL_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,6 @@
 cmake_minimum_required(VERSION 3.1)
 
 find_package(doctest            REQUIRED)
-find_package(Threads)
 
 if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
     project(xtl-test)

=== debian/changelog ===
xtl (0.7.7-1) unstable; urgency=medium

  * New upstream release. Closes: #1082757.

 -- Vincent Bernat <bernat@debian.org>  Mon, 30 Sep 2024 09:19:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: xtl
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Debian QuantStack Team <team+debian-quantstack-team@tracker.debian.org>
+Maintainer: Debian QuantStack Team <team+debian-quantstack-team@tracker.debian.org>
 Uploaders: Vincent Bernat <bernat@debian.org>
-Build-Depends: cmake, debhelper-compat (= 12), libgtest-dev (>= 1.8.1)
+Build-Depends: debhelper-compat (= 12),
+               cmake,
+               libgtest-dev (>= 1.8.1)
 Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/xtensor-stack/xtl

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%xtl-$1.tar.gz%" \
   https://github.com/xtensor-stack/xtl/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## xtl 0.8.1

=== debian/changelog ===
xtl (0.8.1-1~0.1) unstable; urgency=medium

  * NMU upload.
  * New upstream release. Closes: #1101777
    - supports cmake 4. Closes: #1125675
    - drops include/xtl/xvariant_impl.hpp and xany.hpp
      (update debian/copyright)
  * mark xtl-dev Multi-Arch: foreign. Closes: #1112685
  * update debian/watch to v5 GitHub template

 -- Drew Parsons <dparsons@debian.org>  Sun, 08 Feb 2026 11:11:44 +0100

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
 Package: xtl-dev
 Section: libdevel
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: basic tools (containers, algorithms) used for xtensor and xeus
  This package contains additional containers and tools missing from

=== debian/watch ===
Version: 5

Template: GitHub
Owner: xtensor-stack
Project: xtl

## xtl 0.8.2

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # The full license is in the file LICENSE, distributed with this software. #
 ############################################################################
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.29)
 
 find_package(doctest            REQUIRED)
 
@@ -37,7 +37,7 @@
 endif()
 
 if(CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
-    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)
+    add_compile_options(-Werror -Wall -Wextra -Wconversion -Wsign-conversion $<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,12>>:-Wno-stringop-overflow>)
 
     if(NOT CMAKE_CXX_FLAGS MATCHES "-march")
         CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
@@ -60,7 +60,7 @@
 
 if(CMAKE_CXX_COMPILER_ID MATCHES Clang)
   if(NOT WIN32)
-    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)
+    add_compile_options(-Werror -Wall -Wextra -Wconversion -Wsign-conversion)
 
     if(NOT CMAKE_CXX_FLAGS MATCHES "-march")
         CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
@@ -93,7 +93,7 @@
     test_xfunctional.cpp
     test_xhalf_float.cpp
     test_xhash.cpp
-    test_xhierarchy_generator.cpp
+    # test_xhierarchy_generator.cpp
     test_xiterator_base.cpp
     test_xmasked_value.cpp
     test_xmeta_utils.cpp
@@ -104,7 +104,6 @@
     test_xplatform.cpp
     test_xproxy_wrapper.cpp
     test_xsystem.cpp
-    test_xvariant.cpp
     test_xvisitor.cpp
 )

=== debian/changelog ===
xtl (0.8.2-1~0.1) unstable; urgency=medium

  * NMU upload.
  * New upstream release
  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Feb 2026 10:54:59 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 12),
                cmake,
                libgtest-dev (>= 1.8.1)
-Standards-Version: 4.5.0
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://github.com/xtensor-stack/xtl
 Vcs-Browser: https://github.com/quantstack-debian/xtl
